<?php
	
	//EM4x Encode Function
	function decodeEM4x($data)
	{
		//binary
		$binary = preg_replace('/[^0-1]/','',$data);
		//binary_reverse
		$binary_reverse = str_replace(2, 1, str_replace(array(0,1), array(2,0), $binary)); 
		//binary_inverted
		$binary_inverted = strrev($binary);
		//binary_inverted_reverse
		$binary_inverted_reverse = str_replace(2, 1, str_replace(array(0,1), array(2,0), $binary_inverted)); 
		
		//Lets find the binary strings -- forward
		$possibleData = explode("111111111",$binary);
		//binary -- reverse
		$possibleData = array_merge($possibleData,explode("111111111",$binary_reverse));
		//binary -- inverted
		$possibleData = array_merge($possibleData,explode("111111111",$binary_inverted));
		//binary -- inverted+revers
		$possibleData = array_merge($possibleData,explode("111111111",$binary_inverted_reverse));
		
		//unique our arrays so we don't get duplicates
		$possibleData = array_unique($possibleData);
		
		
		$results = array();
		
		foreach($possibleData as $d)
		{
			if(strlen($d) == 55)
			{
				$parityPass = true;
				//echo "adding.";
				$data = array();
				$dataTmp = str_split($d);
				$data = array_chunk($dataTmp,5);
				
				
				//check row parity
				$numItems = 4;
				$parityCheck = 2;
				for($i=0;$i<10;$i++)
				{
					$count = 0;
					for($x=0;$x<$numItems;$x++)
					{
						$count += $data[$i][$x];
					}
					
					if(($count % $parityCheck) == 0)
					{
						if($data[$i][$numItems] == 0)
						{
							$data[$i][$numItems+1] = 'Y';
						}
						else
						{
							$data[$i][$numItems+1] = 'N';
							$parityPass = false;
						}
					}
					else
					{
						if($data[$i][$numItems] == 1)
						{
							$data[$i][$numItems+1] = 'Y';
						}
						else
						{
							$data[$i][$numItems+1] = 'N';
							$parityPass = false;
						}
					}
				}
				
				
				//check col parity
				$numItems = 10;
				for($i=0;$i<4;$i++)
				{
					$count = 0;
					for($x=0;$x<$numItems;$x++)
					{
						$count += $data[$x][$i];
					}
					
					if(($count % $parityCheck) == 0)
					{
						if($data[$numItems][$i] == 0)
						{
							$data[$numItems+1][] = 'Y';
						}
						else
						{
							$data[$numItems+1][] = 'N';
							$parityPass = false;
						}
					}
					else
					{
						if($data[$numItems][$i] == 1)
						{
							$data[$numItems+1][] = 'Y';
						}
						else
						{
							$data[$numItems+1][]= 'N';
							$parityPass = false;
						}
					}
					
				}
				
				
				$hexbin = "";
				for($x=0;$x<10;$x++)
				{
					for($y=0;$y<4;$y++)
					{
						$hexbin .=  $data[$x][$y];
					}
				}
				$hex = base_convert($hexbin,2,16); 

				$fullBinary = "111111111" . $d;
				$invertBinary = str_replace(2, 1, str_replace(array(0,1), array(2,0), $fullBinary)); 
				$results[] = array("parityPass" => $parityPass,"data"=>$data, "hex" => $hex,"binary"=>$d,"full"=>$fullBinary,"invert"=>$invertBinary);

			}
			
			

		}
		return $results;
			
	}
	
	
	
	function encodeEM4x($dec,$manuf="0f")
	{
		
		//$hex = "f007b22d8"
		
		$fullBin = "";
		$hex = base_convert($dec,10,16); 
		if(strlen($hex) < 8)
		{
			for($i=0;$i<(strlen($hex) % 8);$i++)
			{
				$hex = "0" . $hex;
			}
		}

		$hex = "f" . $manuf . $hex;

		
		$bin = substr(base_convert($hex,16,2),4);
		$hex = substr($hex,1);
		
		$dataTmp = str_split($bin);
		$data = array_chunk($dataTmp,4);
		$parityRow = array(0,0,0,0,0);
		$tagBin = "";
		foreach($data as $k=>$v)
		{
			
			$parity = 0;
			$col = 0;
			foreach($v as $vv)
			{
				$fullBin .= $vv;
				$parityRow[$col] += $vv;
				$parity += $vv;
				$col++;
				$tagBin .= $vv;
			}
			//$data[$k][] = $parity;
			
			if($parity % 2)
				$parity = 1;
			else
				$parity = 0;
			$fullBin .= $parity;
			$data[$k][] = $parity;
			$data[$k][] = 'Y';

		}
		
		foreach($parityRow as $k=>$pr)
		{
			if($pr % 2 ==0)
				$parityRow[$k] = 0;
			else
				$parityRow[$k] = 1;
			
			$fullBin .= $parityRow[$k];
		}
		
		$data[11] = $parityRow;
		$data[12] = array('Y','Y','Y','Y');
		$fullBinary = "111111111" . $fullBin;
		$tagID = bindec(substr($tagBin,10));
		$hexTag = base_convert($tagBin,2,16);
		$invertBinary = str_replace(2, 1, str_replace(array(0,1), array(2,0), $fullBinary)); 
		$results[] = array("parityPass" => True,"data"=>$data, "hex" => $hexTag,"binary"=>$fullBin,"full"=>$fullBinary,"invert"=>$invertBinary,"tag"=>$tagID);
		
		return $results;
		//print_r($results);
	}
	
	//encodeEM4x("8069848");
	